# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define oname   lucene

Summary:        High-performance, full-featured text search engine
Name:           lucene22
Version:        2.2.0
Release:        1%{dist}
Epoch:          0
License:        Apache Software License 2.0
URL:            http://lucene.apache.org/
Group:          Internet/WWW/Indexing/Search
#Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
#Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
Source0:        http://www.apache.org/dist/lucene/java/lucene-2.2.0-src.tar.gz
Source1:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-analyzers/2.2.0/lucene-analyzers-2.2.0.pom
Source2:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-ant/2.2.0/lucene-ant-2.2.0.pom
Source3:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-bdb-je/2.2.0/lucene-bdb-je-2.2.0.pom
Source4:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-bdb/2.2.0/lucene-bdb-2.2.0.pom
Source5:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-benchmark/2.2.0/lucene-benchmark-2.2.0.pom
Source6:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-contrib/2.2.0/lucene-contrib-2.2.0.pom
Source7:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-core/2.2.0/lucene-core-2.2.0.pom
Source8:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-demos/2.2.0/lucene-demos-2.2.0.pom
Source9:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-highlighter/2.2.0/lucene-highlighter-2.2.0.pom
Source10:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-lucli/2.2.0/lucene-lucli-2.2.0.pom
Source11:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-memory/2.2.0/lucene-memory-2.2.0.pom
Source12:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-misc/2.2.0/lucene-misc-2.2.0.pom
Source13:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-parent/2.2.0/lucene-parent-2.2.0.pom
Source14:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-queries/2.2.0/lucene-queries-2.2.0.pom
Source15:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-regex/2.2.0/lucene-regex-2.2.0.pom
Source16:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-snowball/2.2.0/lucene-snowball-2.2.0.pom
Source17:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-spellchecker/2.2.0/lucene-spellchecker-2.2.0.pom
Source18:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-surround/2.2.0/lucene-surround-2.2.0.pom
Source19:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-swing/2.2.0/lucene-swing-2.2.0.pom
Source20:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-similarity/2.2.0/lucene-similarity-2.2.0.pom
Source21:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-wordnet/2.2.0/lucene-wordnet-2.2.0.pom
Source22:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-xml-query-parser/2.2.0/lucene-xml-query-parser-2.2.0.pom
Patch0:         lucene22-GOMStaxWriter.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  berkeleydb >= 0:2.0.90
BuildRequires:  berkeleydb-native >= 0:4.3.29
BuildRequires:  junit
BuildRequires:  javacc
BuildRequires:  java-javadoc

BuildRequires:  bea-stax
BuildRequires:  easymock-java5
BuildRequires:  hessian-nodep
BuildRequires:  hivemind
BuildRequires:  hivemind-jmx
BuildRequires:  hivemind-lib
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-logging
BuildRequires:  jline
BuildRequires:  jtidy
BuildRequires:  log4j
BuildRequires:  nekohtml
BuildRequires:  regexp
BuildRequires:  stax_1_0_api

Requires:  java >= 0:1.5.0
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
Jakarta Lucene is a high-performance, full-featured text search engine
written entirely in Java. It is a technology suitable for nearly any
application that requires full-text search, especially cross-platform.

%package javadoc
Summary:        Javadoc for Lucene
Group:          Development/Documentation

%description javadoc
%{summary}.

%package demo
Summary:        Lucene demonstration library
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
%{summary}.

%package contrib
Summary:        Lucene contributed extensions
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jline

%description contrib
%{summary}.

%package contrib-benchmark
Summary:        Lucene contributed benchmark
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-digester
Requires:  jakarta-commons-logging
Requires:  xerces-j2
Requires:  xml-commons-jaxp-1.3-apis

%description contrib-benchmark
%{summary}.

%package contrib-db
Summary:        Lucene contributed bdb extensions
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:  berkeleydb >= 0:2.0.90
Requires:  berkeleydb-native >= 0:4.3.29

%description contrib-db
%{summary}.


%prep
%setup -q -n %{oname}-%{version}
# remove all binary libs
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done


pushd contrib/gdata-server/lib
ln -sf $(build-classpath commons-beanutils)
ln -sf $(build-classpath commons-collections) commons-collections-3.2.jar
ln -sf $(build-classpath commons-digester) commons-digester-1.7.jar
ln -sf $(build-classpath commons-logging) commons-logging-1.1.jar
mv gdata-client-1.0.jar.no gdata-client-1.0.jar
ln -sf $(build-classpath log4j) log4j-1.2.13.jar
ln -sf $(build-classpath nekohtml)
ln -sf $(build-classpath servlet_2_4_api) servlet-api.jar
ln -sf $(build-classpath xerces-j2) xercesImpl.jar
popd 
mkdir -p contrib/gdata-server/ext-libs/
pushd contrib/gdata-server/ext-libs/
ln -sf $(build-classpath easymock-java5) easymock-1.2_Java1.5.jar
ln -sf $(build-classpath hessian-nodep) hessian-3.0.20.jar
ln -sf $(build-classpath hivemind) hivemind-1.1.jar
ln -sf $(build-classpath hivemind-jmx) hivemind-jmx-1.1.jar
ln -sf $(build-classpath hivemind-lib) hivemind-lib-1.1.jar
ln -sf $(build-classpath javassist) javassist-3.0.jar
ln -sf $(build-classpath oro) oro-2.0.6.jar
ln -sf $(build-classpath stax_1_0_api) stax-api-1.0.1.jar
ln -sf $(build-classpath bea-stax-ri) stax-1.1.2-dev.jar
popd

pushd contrib/benchmark/lib
ln -sf $(build-classpath commons-digester) commons-digester-1.7.jar
ln -sf $(build-classpath commons-collections) commons-collections-3.1.jar
ln -sf $(build-classpath commons-logging) commons-logging-1.0.4.jar
ln -sf $(build-classpath commons-beanutils) commons-beanutils-1.7.0.jar
ln -sf $(build-classpath xerces-j2) xerces-2.9.0.jar
ln -sf $(build-classpath xml-commons-jaxp-1.3-apis) xml-apis-2.9.0.jar
popd
pushd contrib/lucli/lib
ln -sf $(build-classpath jline) jline.jar
popd
mkdir -p contrib/db/bdb/lib
pushd contrib/db/bdb/lib
ln -sf $(build-classpath berkeleydb-native) db-4.3.29.jar
popd
mkdir -p contrib/db/bdb-je/lib/je-2.0.90/lib
pushd contrib/db/bdb-je/lib/je-2.0.90/lib
ln -sf $(build-classpath berkeleydb) je.jar
popd
mkdir -p contrib/regex/lib
pushd contrib/regex/lib
ln -sf $(build-classpath regexp) jakarta-regexp-1.4.jar
popd

%patch0 -b .sav0

%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0

ant package-all-binary

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 build/%{oname}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 0644 build/%{oname}-demos-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-demos-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# contrib jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib
for c in analyzers ant benchmark highlighter lucli memory misc queries regex similarity snowball spellchecker surround swing similarity wordnet xml-query-parser; do
    install -m 0644 build/contrib/$c/%{oname}-${c}-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib/${c}-%{version}.jar
done

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# benchmark contrib jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-benchmark
install -m 0644 build/contrib/benchmark/%{oname}-benchmark-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-benchmark/benchmark-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-benchmark && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# bdb contrib jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db
install -m 0644 build/contrib/db/bdb/%{oname}-bdb-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db/bdb-%{version}.jar
install -m 0644 build/contrib/db/bdb-je/%{oname}-bdb-je-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db/bdb-je-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# poms
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-analyzers.pom
%add_to_maven_depmap org.apache.lucene lucene-analyzers %{version} JPP/%{name}-contrib analyzers
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-ant.pom
%add_to_maven_depmap org.apache.lucene lucene-ant %{version} JPP/%{name}-contrib ant
install -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-db-bdb-je.pom
%add_to_maven_depmap org.apache.lucene lucene-bdb-je %{version} JPP/%{name}-contrib-db bdb-je
install -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-db-bdb.pom
%add_to_maven_depmap org.apache.lucene lucene-bdb %{version} JPP/%{name}-contrib-db bdb
install -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-benchmark-benchmark.pom
%add_to_maven_depmap org.apache.lucene lucene-benchmark %{version} JPP/%{name}-contrib-benchmark benchmark
install -m 0644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib.pom
%add_to_maven_depmap org.apache.lucene lucene-contrib %{version} JPP/%{name} contrib
install -m 0644 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.apache.lucene lucene-core %{version} JPP %{name}
install -m 0644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-demos.pom
%add_to_maven_depmap org.apache.lucene lucene-demos %{version} JPP %{name}-demos
install -m 0644 %{SOURCE9} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-highlighter.pom
%add_to_maven_depmap org.apache.lucene lucene-highlighter %{version} JPP/%{name}-contrib highlighter
install -m 0644 %{SOURCE10} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-lucli.pom
%add_to_maven_depmap org.apache.lucene lucene-lucli %{version} JPP/%{name}-contrib lucli
install -m 0644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-memory.pom
%add_to_maven_depmap org.apache.lucene lucene-memory %{version} JPP/%{name}-contrib memory
install -m 0644 %{SOURCE12} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-misc.pom
%add_to_maven_depmap org.apache.lucene lucene-misc %{version} JPP/%{name}-contrib misc
install -m 0644 %{SOURCE13} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.lucene lucene-parent %{version} JPP/%{name} parent
install -m 0644 %{SOURCE14} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-queries.pom
%add_to_maven_depmap org.apache.lucene lucene-queries %{version} JPP/%{name}-contrib queries
install -m 0644 %{SOURCE15} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-regexp.pom
%add_to_maven_depmap org.apache.lucene lucene-regexp %{version} JPP/%{name}-contrib regexp
install -m 0644 %{SOURCE16} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-snowball.pom
%add_to_maven_depmap org.apache.lucene lucene-snowball %{version} JPP/%{name}-contrib snowball
install -m 0644 %{SOURCE17} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-spellchecker.pom
%add_to_maven_depmap org.apache.lucene lucene-spellchecker %{version} JPP/%{name}-contrib spellchecker
install -m 0644 %{SOURCE18} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-surround.pom
%add_to_maven_depmap org.apache.lucene lucene-surround %{version} JPP/%{name}-contrib surround
install -m 0644 %{SOURCE19} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-swing.pom
%add_to_maven_depmap org.apache.lucene lucene-swing %{version} JPP/%{name}-contrib swing
install -m 0644 %{SOURCE20} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-similarity.pom
%add_to_maven_depmap org.apache.lucene lucene-similarity %{version} JPP/%{name}-contrib similarity
install -m 0644 %{SOURCE21} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-wordnet.pom
%add_to_maven_depmap org.apache.lucene lucene-wordnet %{version} JPP/%{name}-contrib wordnet
install -m 0644 %{SOURCE22} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-xml-query-parser.pom
%add_to_maven_depmap org.apache.lucene lucene-xml-query-parser %{version} JPP/%{name}-contrib xml-query-parser

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/api/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# webapp
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 0644 build/%{oname}web.war \
  $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CHANGES.txt LICENSE.txt README.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/%{name}-%{version}
%{_datadir}/maven2/poms
%{_mavendepmapfragdir}


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files contrib
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-contrib

%files contrib-benchmark
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-contrib-benchmark

%files contrib-db
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-contrib-db

%files demo
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-demos-%{version}.jar
%{_javadir}/%{name}-demos.jar


%changelog
* Tue Jun 17 2008 Ralph Apel <r.apel at r-apel.de> 0:2.2.0-1.jpp5
- 2.2.0 as lucene22

* Wed Mar 29 2006 Ralph Apel <r.apel@r-apel.de> 0:1.9.1-1jpp
- Upgrade to 1.9.1

* Tue Apr 26 2005 Ville Skyttä <scop at jpackage.org> - 0:1.4.3-2jpp
- Add unversioned javadoc dir symlink.
- Crosslink with local JDK javadocs.
- Convert specfile to UTF-8.
- Fix URLs.

* Mon Jan 10 2005 Kaj J. Niemi <kajtzu@fi.basen.net> 0:1.4.3
- 1.4.3

* Mon Aug 23 2004 Fernando Nasser <fnasser at redhat.com> - 0:1.3-3jpp
- Rebuild with Ant 1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.3-2jpp
- Upgrade to Ant 1.6.X

* Wed Jan 21 2004 David Walluck <david@anti-microsoft.org> 0:1.3-1jpp
- 1.3

* Wed Mar 26 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2-2jpp
- Rebuilt for JPackage 1.5.

* Thu Mar  6 2003 Ville Skyttä <scop at jpackage.org> - 1.2-1jpp
- First JPackage release.
